﻿using System;
using System.IO;
using System.Net;
using System.Text;
using System.Linq;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Net.Http.Formatting;
using System.Reflection;
using System.Threading;
using System.Threading.Tasks;
using System.Collections.Generic;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Json;
using System.Runtime.InteropServices.WindowsRuntime;

using Windows.UI.Popups;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.System;
using Windows.Storage;
using Windows.Networking;
using Windows.Networking.Connectivity;
using Windows.ApplicationModel.Background;

using System.Diagnostics;
using Windows.System.Threading;


// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=391641


namespace NestAway
{
    public sealed partial class MainPage : Page
    {
        public MainPage()
        {
            this.InitializeComponent();
            this.NavigationCacheMode = NavigationCacheMode.Required;

            var settings = ApplicationData.Current.LocalSettings;
            var key = "nameHomeWifi";
            textWifiName.Text = " " + settings.Values[key];
        }
        protected override void OnNavigatedTo(NavigationEventArgs e)
        {  }

        private async void buttonRegisterWifiMonitor_Click(object sender, RoutedEventArgs e)
        {
            // Get Home Wifi Name
            var ssid = "";
            foreach (var connectionProfile in NetworkInformation.GetConnectionProfiles())
            {
                if (connectionProfile.IsWlanConnectionProfile && connectionProfile.GetNetworkConnectivityLevel() != NetworkConnectivityLevel.None)
                {
                    ssid = connectionProfile.ProfileName;
                    var settings = ApplicationData.Current.LocalSettings;
                    var key = "nameHomeWifi";
                    settings.Values[key] = ssid;
                    textWifiName.Text = ssid;
                    break;
                }
            }
            // Register Background process
            string myTaskName = "BackgroundWifiCheck";
            // check if task is already registered
            foreach (var cur in BackgroundTaskRegistration.AllTasks)
                if (cur.Value.Name == myTaskName)
                {
                    await (new MessageDialog("Wifi Monitor is already registered")).ShowAsync();
                    return;
                }
            // Windows Phone app must call this to use trigger types (see MSDN)
            await BackgroundExecutionManager.RequestAccessAsync();
            // register a new task
            BackgroundTaskBuilder taskBuilder = new BackgroundTaskBuilder();
            taskBuilder.Name = myTaskName;
            SystemTrigger trigger = new SystemTrigger(SystemTriggerType.NetworkStateChange, false);
            taskBuilder.SetTrigger(trigger);
            taskBuilder.TaskEntryPoint = typeof(BackgroundWifiCheck.TheTask).FullName;
            BackgroundTaskRegistration registration = taskBuilder.Register();
            await (new MessageDialog("Wifi Monitor is now registered")).ShowAsync();
        }
    }
}
